Main Page Modules Data Structures File List Data Fields Globals Related Pages

# rpmio/rpmmacro.h File Reference

More...

Go to the source code of this file.

## Data Structures

struct | MacroContext_s
struct | MacroEntry_s

## Defines

#define | RMIL_DEFAULT -15
| Markers for sources of macros added throughout rpm. More...
#define | RMIL_MACROFILES -13
#define | RMIL_RPMRC -11
#define | RMIL_CMDLINE -7
#define | RMIL_TARBALL -5
#define | RMIL_SPEC -3
#define | RMIL_OLDSPEC -1
#define | RMIL_GLOBAL 0

## Typedefs

typedef MacroEntry_s * | MacroEntry
typedef MacroContext_s * | MacroContext
typedef enum rpmCompressedMagic_e | rpmCompressedMagic

## Enumerations

enum | rpmCompressedMagic_e { COMPRESSED_NOT = 0, COMPRESSED_OTHER = 1, COMPRESSED_BZIP2 = 2, COMPRESSED_ZIP = 3 }

## Functions

void | rpmDumpMacroTable (MacroContext mc, FILE *fp)
| Print macros to file stream. More...
int | expandMacros (void *spec, MacroContext mc, char *sbuf, size_t slen)
| Expand macro into buffer. More...
void | addMacro (MacroContext mc, const char *n, const char *o, const char *b, int level)
| Add macro to context. More...
void | delMacro (MacroContext mc, const char *n)
| Delete macro from context. More...
int | rpmDefineMacro (MacroContext mc, const char *macro, int level)
| Define macro in context. More...
void | rpmLoadMacros (MacroContext mc, int level)
| Load macros from specific context into global context. More...
void | rpmInitMacros (MacroContext mc, const char *macrofiles)
| Initialize global macro context from set of macrofile(s). More...
void | rpmFreeMacros (MacroContext mc)
| Destroy macro context. More...
int | isCompressed (const char *file, rpmCompressedMagic *compressed)
| Return type of compression used in file. More...
char * | rpmExpand (const char *arg,...)
| Return (malloc'ed) concatenated macro expansion(s). More...
char * | rpmCleanPath (char *path)
| Canonicalize file path. More...
const char * | rpmGetPath (const char *path,...)
| Return (malloc'ed) expanded, canonicalized, file path. More...
const char * | rpmGenPath (const char *urlroot, const char *urlmdir, const char *urlfile)
| Merge 3 args into path, any or all of which may be a url. More...
int | rpmExpandNumeric (const char *arg)
| Return macro expansion as a numeric value. More...

## Variables

MacroContext | rpmGlobalMacroContext
MacroContext | rpmCLIMacroContext
const char * | macrofiles

## Detailed Description

Definition in file rpmmacro.h.

## Define Documentation

#define RMIL_CMDLINE -7

| Definition at line 50 of file rpmmacro.h. Referenced by ftsCacheUpdate, rpmcliAllArgCallback, and rpmInitMacros.

#define RMIL_DEFAULT -15

| Markers for sources of macros added throughout rpm. Definition at line 46 of file rpmmacro.h. Referenced by main, rpmtsOpenSDB, setDefaults, setPathDefault, and setVarDefault.

#define RMIL_GLOBAL 0

| Definition at line 54 of file rpmmacro.h. Referenced by expandMacro.

#define RMIL_MACROFILES -13

| Definition at line 47 of file rpmmacro.h. Referenced by rpmInitMacros.

#define RMIL_OLDSPEC -1

| Definition at line 53 of file rpmmacro.h. Referenced by handlePreambleTag.

#define RMIL_RPMRC -11

| Definition at line 48 of file rpmmacro.h. Referenced by doReadRC, parseSpec, and rpmRebuildTargetVars.

#define RMIL_SPEC -3

| Definition at line 52 of file rpmmacro.h. Referenced by addSource, doScript, doSetupMacro, handlePreambleTag, and parseSpec.

#define RMIL_TARBALL -5

| Definition at line 51 of file rpmmacro.h. Referenced by buildForTarget.

## Typedef Documentation

typedef struct MacroContext_s * MacroContext

| The structure used to store the set of macros in a context.

typedef struct MacroEntry_s * MacroEntry

| The structure used to store a macro.

typedef enum rpmCompressedMagic_e rpmCompressedMagic

| Referenced by buildForTarget, doFoo, doPatch, doUntar, and isCompressed.

## Enumeration Type Documentation

enum rpmCompressedMagic_e

Enumeration values:

  COMPRESSED_NOT | not compressed
  COMPRESSED_OTHER | gzip can handle
  COMPRESSED_BZIP2 | bzip2 can handle
  COMPRESSED_ZIP | unzip can handle

Definition at line 151 of file rpmmacro.h.

## Function Documentation

void addMacro | ( | MacroContext | mc,
|  | const char * | n,
|  | const char * | o,
|  | const char * | b,
|  | int | level
| ) |

Add macro to context.

Deprecated:
  Use rpmDefineMacro().

Parameters:

  mc | macro context (NULL uses global context).
  n | macro name
  o | macro paramaters
  b | macro body
  level | macro recursion level (0 is entry API)

Definition at line 1507 of file macro.c.

Referenced by addSource, buildForTarget, doDefine, doReadRC, doScript, doSetupMacro, expandMacro, grabArgs, handlePreambleTag, main, makeGPGSignature, makePGPSignature, parseSpec, rpmLoadMacros, rpmPlatform, rpmrc_AddMacro, rpmRebuildTargetVars, rpmtsOpenSDB, setDefaults, setPathDefault, and setVarDefault.

void delMacro | ( | MacroContext | mc,
|  | const char * | n
| ) |

Delete macro from context.

Parameters:

  mc | macro context (NULL uses global context).
  n | macro name

Definition at line 1533 of file macro.c.

Referenced by doScript, doUndefine, handlePreambleTag, makeGPGSignature, makePGPSignature, parseSpec, rpmrc_DelMacro, rpmRebuildTargetVars, and rpmtsOpenSDB.

int expandMacros | ( | void * | spec,
|  | MacroContext | mc,
|  | char * | sbuf,
|  | size_t | slen
| ) |

Expand macro into buffer.

Deprecated:
  Use rpmExpand().

Todo:
  Eliminate from API.

Parameters:

  spec | cookie (unused)
  mc | macro context (NULL uses global context).

Return values:

  sbuf | input macro to expand, output expansion

Parameters:

  slen | size of buffer

Returns:
  0 on success

Definition at line 1472 of file macro.c.

Referenced by addFileToTagAux, copyNextLine, processPackageFiles, rpmExpand, and rpmGetPath.

int isCompressed | ( | const char * | file,
|  | rpmCompressedMagic * | compressed
| ) |

Return type of compression used in file.

Parameters:

  file | name of file

Return values:

  compressed | address of compression type

Returns:
  0 on success, 1 on I/O error

Definition at line 1681 of file macro.c.

Referenced by buildForTarget, doFoo, doPatch, and doUntar.

char* rpmCleanPath | ( | char * | path | ) |

Canonicalize file path.

Parameters:

  path | path to canonicalize (in-place)

Returns:
  canonicalized path (malloc'ed)

Definition at line 1783 of file macro.c.

Referenced by doLookup, rpmdbMoveDatabase, rpmdbRemoveDatabase, rpmGetPath, and rpmQueryVerify.

int rpmDefineMacro | ( | MacroContext | mc,
|  | const char * | macro,
|  | int | level
| ) |

Define macro in context.

Parameters:

  mc | macro context (NULL uses global context).
  macro | macro name, options, body
  level | macro recursion level (0 is entry API)

Returns:

Todo:
  Document.

Definition at line 1549 of file macro.c.

Referenced by ftsCacheUpdate, rpmcliAllArgCallback, rpmdbRebuild, and rpmInitMacros.

void rpmDumpMacroTable | ( | MacroContext | mc,
|  | FILE * | fp
| ) |

Print macros to file stream.

Parameters:

  mc | macro context (NULL uses global context).
  fp | file stream (NULL uses stderr).

Definition at line 202 of file macro.c.

Referenced by expandMacro, and rpmShowRC.

char* rpmExpand | ( | const char * | arg,
|  | ... |
| ) |

Return (malloc'ed) concatenated macro expansion(s).

Parameters:

  arg | macro(s) to expand (NULL terminates list)

Returns:
  macro expansion (malloc'ed)

Definition at line 1733 of file macro.c.

Referenced by checkFiles, checkForValidArchitectures, checkPassPhrase, cpio_doio, dbiTagsInit, defaultMachine, doPrimary, doScript, doSetupMacro, fillOutMainPackage, generateDepends, i18nTag, ignoreDep, initGlobs, main, makeGPGSignature, makePGPSignature, newRpmdb, open_dso, packageBinaries, parseForRegexLang, parseForRegexMultiLib, parseSpec, rdToken, readLine, rpmcliAllArgCallback, rpmdbSetIteratorRE, rpmExpandNumeric, rpmGetPassPhrase, rpmLookupSignatureType, rpmPlatform, rpmReadConfigFiles, rpmRollback, rpmts_IDTXglob, rpmtsFindPubkey, rpmtsSolve, urlFind, and writeRPM.

int rpmExpandNumeric | ( | const char * | arg | ) |

Return macro expansion as a numeric value.

Boolean values ('Y' or 'y' returns 1, 'N' or 'n' returns 0) are permitted as well. An undefined macro returns 0.

Parameters:

  arg | macro to expand

Returns:
  numeric value

Definition at line 1756 of file macro.c.

Referenced by build, checkFiles, dbiOpen, genCpioListAndHeader, main, newRpmdb, parseRCPOT, parseSpec, processPackageFiles, rpmcliQuery, rpmcliVerify, rpmdbInit, rpmdbOpen, rpmdbRebuild, rpmdbVerify, rpmErase, rpmInstall, rpmLeadVersion, rpmRollback, rpmts_Create, and rpmtsOpenSDB.

void rpmFreeMacros | ( | MacroContext | mc | ) |

Destroy macro context.

Parameters:

  mc | macro context (NULL uses global context).

Definition at line 1654 of file macro.c.

Referenced by build, and main.

const char* rpmGenPath | ( | const char * | urlroot,
|  | const char * | urlmdir,
|  | const char * | urlfile
| ) |

Merge 3 args into path, any or all of which may be a url.

The leading part of the first URL encountered is used for the result, other URL prefixes are discarded, permitting a primitive form of URL inheiritance.

Parameters:

  urlroot | root URL (often path to chroot, or NULL)
  urlmdir | directory URL (often a directory, or NULL)
  urlfile | file URL (often a file, or NULL)

Returns:
  expanded, merged, canonicalized path (malloc'ed)

Definition at line 1902 of file macro.c.

Referenced by buildForTarget, db3close, db3open, db_init, doScript, doSetupMacro, handlePreambleTag, makeTempFile, processBinaryFile, processPackageFiles, and rpmInstall.

const char* rpmGetPath | ( | const char * | path,
|  | ... |
| ) |

Return (malloc'ed) expanded, canonicalized, file path.

Parameters:

  path | macro(s) to expand (NULL terminates list)

Returns:
  canonicalized path (malloc'ed)

Definition at line 1871 of file macro.c.

Referenced by addFileToTagAux, addSource, buildForTarget, db3close, db3open, doPatch, doReadRC, doRmSource, doUntar, newRpmdb, packageBinaries, packageSources, parseFiles, parseForSimple, parseSpec, processPackageFiles, processSourceFiles, readIcon, rpmdbRebuild, rpmDetectPGPVersion, rpmGenPath, rpmGetFilesystemUsage, rpmtsOpenDB, rpmtsOpenSDB, and setPathDefault.

void rpmInitMacros | ( | MacroContext | mc,
|  | const char * | macrofiles
| ) |

Initialize global macro context from set of macrofile(s).

Parameters:

  mc | (unused)
  macrofiles | colon separated list of macro files (NULL does nothing)

Definition at line 1583 of file macro.c.

Referenced by rpmReadRC.

void rpmLoadMacros | ( | MacroContext | mc,
|  | int | level
| ) |

Load macros from specific context into global context.

Parameters:

  mc | macro context (NULL does nothing).
  level | macro recursion level (0 is entry API)

Definition at line 1562 of file macro.c.

Referenced by rpmInitMacros.

## Variable Documentation

MacroContext rpmCLIMacroContext

| Definition at line 30 of file rpmmacro.h.

MacroContext rpmGlobalMacroContext

| Definition at line 27 of file rpmmacro.h.